/*************************************************************************************
*  Common constants/variables/macros/includes for bsfw
*  by:      BSVi
*  version: 1.03
*************************************************************************************/
#ifndef COMMONINC_H_
#define COMMONINC_H_

//------------------------------------------------------------------------------
// Fixed size and commonly used data types and their limits
//------------------------------------------------------------------------------
typedef unsigned char	      uint8;
typedef unsigned short        uint16;
typedef unsigned long         uint32;
//typedef unsigned long long    uint64;

typedef signed char	      int8;
typedef signed short	      int16;
typedef signed long	      int32;
//typedef signed long long      int64;

typedef unsigned int          uint;

#define uint32_max 0xffffffff
#define uint16_max 0xffff
#define uint8_max  0xff


#ifndef NULL
   #define NULL (void*)0
#endif /* NULL */


// todo: add signed limits

//------------------------------------------------------------------------------
// BITs definitions
//------------------------------------------------------------------------------
#ifndef BIT0
#define BIT0                (1<<0)
#define BIT1                (1<<1)
#define BIT2                (1<<2)
#define BIT3                (1<<3)
#define BIT4                (1<<4)
#define BIT5                (1<<5)
#define BIT6                (1<<6)
#define BIT7                (1<<7)
#define BIT8                (1<<8)
#define BIT9                (1<<9)
#define BIT10               (1<<10)
#define BIT11               (1<<11)
#define BIT12               (1<<12)
#define BIT13               (1<<13)
#define BIT14               (1<<14)
#define BIT15               (1<<15)
#define BIT16               ((uint32)1<<16)
#define BIT17               ((uint32)1<<17)
#define BIT18               ((uint32)1<<18)
#define BIT19               ((uint32)1<<19)
#define BIT20               ((uint32)1<<20)
#define BIT21               ((uint32)1<<21)
#define BIT22               ((uint32)1<<22)
#define BIT23               ((uint32)1<<23)
#define BIT24               ((uint32)1<<24)
#define BIT25               ((uint32)1<<25)
#define BIT26               ((uint32)1<<26)
#define BIT27               ((uint32)1<<27)
#define BIT28               ((uint32)1<<28)
#define BIT29               ((uint32)1<<29)
#define BIT30               ((uint32)1<<30)
#define BIT31               ((uint32)1<<31)
#endif


//------------------------------------------------------------------------------
// Compiller-specific includes
//------------------------------------------------------------------------------
#ifdef __IAR_SYSTEMS_ICC__
#include <intrinsics.h>
#define DINT() __disable_interrupt()
#define EINT() __enable_interrupt()
#define nop()  __no_operation();
#endif

//------------------------------------------------------------------------------
// Common macros
//------------------------------------------------------------------------------

#define array_size(a) ( sizeof(a)/sizeof(*(a)) )

#define _BV(n) (1 << (n))
#define MIN(n,m) (((n) < (m)) ? (n) : (m))
#define MAX(n,m) (((n) < (m)) ? (m) : (n))
#define ABS(n) (((n) < 0) ? -(n) : (n))

#define HIBYTE(a) (*((uint8*)&(a) + 1))
#define LOBYTE(a) (*((uint8*)&(a)))
#define HIWORD(a) (*((uint16*)&(a) + 1))
#define LOWORD(a) (*((uint16*)&(a)))


//------------------------------------------------------------------------------
// Define asserts macros
//------------------------------------------------------------------------------
#ifndef NO_ASSERTS
   #define ASSERT_HANDLER {while(1) {;}}
#else
   #define ASSERT_HANDLER  {}
#endif

#define ASSERT(expr)          if (!(expr)) ASSERT_HANDLER();
#define STATIC_ASSERT(expr)   void DummyPrototype( char dummy[1/((expr)!=0)] );

//------------------------------------------------------------------------------
// Check fixed size variables sizes
//------------------------------------------------------------------------------
STATIC_ASSERT( sizeof(  uint8 ) == 1 );
STATIC_ASSERT( sizeof(   int8 ) == 1 );
STATIC_ASSERT( sizeof( uint16 ) == 2 );
STATIC_ASSERT( sizeof(  int16 ) == 2 );
STATIC_ASSERT( sizeof( uint32 ) == 4 );
STATIC_ASSERT( sizeof(  int32 ) == 4 );
//   STATIC_ASSERT( sizeof( uint64 ) == 8 );
//   STATIC_ASSERT( sizeof(  int64 ) == 8 );



#endif /* COMMONINC_H_ */
